import util from './util';

const consoleConfig = [
  {
    key: "dev", // 注册key值
    label: "devLog",  // 标识
    labelColor: "#00f", // 标识颜色
    logColor: "#666", // 日志颜色
  },
]
const dateColor = '#f0f';

const consoleDev = (time, version, branch) => {
  const typeofBase = data => typeof data == 'string' || typeof data == 'number';
  console.branch = () => {
    let arr = [`%c**** branch => ${branch} ****`,`color:${dateColor}`];
    console.log(...arr)
  };
  console.date = () => {
    let arr = [`%c**** devTime => ${time} v${version} ****`,`color:${dateColor}`];
    console.log(...arr)
  };
  console.buildtime = () => {
    let meta = document.querySelector('meta[name="buildtime"]');
    let buildTime = meta ? meta.getAttribute('date') : '';
    let arr = [`%c**** buildTime => ${buildTime} ****`,`color:${dateColor}`];
    console.log(...arr)
  }
  console.detail = () => {
    console.branch();
    console.date();
    console.buildtime();
  }
  
  console.json = (...rest) => console.dev(...rest.map(item => typeofBase(item) ? item : util.deepCopy2(item)));
  // 自动复制
  console.copy = str => {
    if(str) return util.copy(str);
    // copy串联方法
    let copyEvent = {
      href: (token=true) => { // 复制地址 参数为是否带token 默认为true
        let href = location.href;
        let query = '';
        if(token){
          let hasToken = href.indexOf('token' > -1);
          if(!hasToken){
            let hasQuery = href.indexOf('?') > -1;
            query = hasQuery ? '&' : '?';
            query = query + 'token=' + store.state.login.token
          }
        }
        let result = location.href + query;
        return util.copy(result);
      },
      local: (key) => { // 复制本地存储项
        let result = window.localStorage.getItem(key);
        return util.copy(result);
      },
      session: (key) => { // 复制本地存储项
        let result = window.sessionStorage.getItem(key);
        return util.copy(result);
      },
    }
    return copyEvent;
  };
  
  const generateConsole = ({key, label, labelColor, logColor}) => {
    label ? null : label = defaultConfig.label;
    labelColor ? null : labelColor = defaultConfig.labelColor;
    logColor ? null : logColor = defaultConfig.logColor;
    console[key] = (...rest) => {
      if(!rest.length){
        console.detail();
      }else{
        let argStr = [];
        let argOther = [];
        rest.forEach(item => {
          item == undefined ? item = 'undefined' : null;
          return typeofBase(item)
            ? argStr.push(item)
            : argOther.push(item);
        });
        let join = argStr.join(' ')
        let params = [];
        if(join){
          params.push(`%c${label} => %c${join}`);
          params.push(`color:${labelColor}`);
          params.push(`color:${logColor}`);
        }else{
          params.push(`%c${label} =>`);
          params.push(`color:${labelColor}`);
        }
        params = params.concat(argOther);
        params.length && console.log(...params);
      }
    }
  }
  
  consoleConfig.map(conf => generateConsole(conf))
}

export default consoleDev;
